BodyContentImpl (Apache Tomcat 11.0.24 API Documentation)
Description: declaration: package: org.apache.jasper.runtime, class: BodyContentImpl

# Class BodyContentImpl

java.lang.Object
java.io.Writer
jakarta.servlet.jsp.JspWriter
jakarta.servlet.jsp.tagext.BodyContent
org.apache.jasper.runtime.BodyContentImpl

All Implemented Interfaces:
  `Closeable, Flushable, Appendable, AutoCloseable`

public class BodyContentImpl extends BodyContent
Write text to a character-output stream, buffering characters to provide efficient writing of single characters, arrays, and strings. Provide support for discarding the output that has been buffered.

- ## Field Summary

  ### Fields inherited from class JspWriter

  `autoFlush, bufferSize, DEFAULT_BUFFER, NO_BUFFER, UNBOUNDED_BUFFER`

  ### Fields inherited from class Writer

  `lock`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `BodyContentImpl(JspWriter enclosingWriter, boolean limitBuffer, int tagBufferSize)`
  Constructor.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `clear()`
  Clear the contents of the buffer.
  `void`
  `clearBuffer()`
  Clears the current contents of the buffer.
  `void`
  `close()`
  Close the stream, flushing it first.
  `int`
  `getBufferSize()`
  This method returns the size of the buffer used by the JspWriter.
  `Reader`
  `getReader()`
  Return the value of this BodyContent as a Reader.
  `int`
  `getRemaining()`
  This method returns the number of unused bytes in the buffer.
  `String`
  `getString()`
  Return the value of the BodyContent as a String.
  `void`
  `newLine()`
  Write a line separator.
  `void`
  `print(boolean b)`
  Print a boolean value.
  `void`
  `print(char c)`
  Print a character.
  `void`
  `print(char[] s)`
  Print an array of characters.
  `void`
  `print(double d)`
  Print a double-precision floating-point number.
  `void`
  `print(float f)`
  Print a floating-point number.
  `void`
  `print(int i)`
  Print an integer.
  `void`
  `print(long l)`
  Print a long integer.
  `void`
  `print(Object obj)`
  Print an object.
  `void`
  `print(String s)`
  Print a string.
  `void`
  `println()`
  Terminate the current line by writing the line separator string.
  `void`
  `println(boolean x)`
  Print a boolean value and then terminate the line.
  `void`
  `println(char x)`
  Print a character and then terminate the line.
  `void`
  `println(char[] x)`
  Print an array of characters and then terminate the line.
  `void`
  `println(double x)`
  Print a double-precision floating-point number and then terminate the line.
  `void`
  `println(float x)`
  Print a floating-point number and then terminate the line.
  `void`
  `println(int x)`
  Print an integer and then terminate the line.
  `void`
  `println(long x)`
  Print a long integer and then terminate the line.
  `void`
  `println(Object x)`
  Print an Object and then terminate the line.
  `void`
  `println(String x)`
  Print a String and then terminate the line.
  `protected void`
  `recycle()`
  This method shall "reset" the internal state of a BodyContentImpl, releasing all internal references, and preparing it for potential reuse by a later invocation of `PageContextImpl.pushBody(Writer)`.
  `void`
  `write(char[] buf)`
  `void`
  `write(char[] cbuf, int off, int len)`
  `void`
  `write(int c)`
  `void`
  `write(String s)`
  `void`
  `write(String s, int off, int len)`
  `void`
  `writeOut(Writer out)`
  Write the contents of this BodyContent into a Writer.

  ### Methods inherited from class BodyContent

  `clearBody, flush, getEnclosingWriter`

  ### Methods inherited from class JspWriter

  `isAutoFlush`

  ### Methods inherited from class Writer

  `append, append, append, nullWriter`

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### BodyContentImpl

    public BodyContentImpl(JspWriter enclosingWriter, boolean limitBuffer, int tagBufferSize)
    Constructor.
    Parameters:
      `enclosingWriter` - The wrapped writer
      `limitBuffer` - `true` to discard large buffers
      `tagBufferSize` - the buffer size

- ## Method Details

  - ### write

    public void write(int c) throws IOException
    Overrides:
      `write` in class `Writer`
    Throws:
      `IOException`

  - ### write

    public void write(char[] cbuf, int off, int len) throws IOException
    Specified by:
      `write` in class `Writer`
    Throws:
      `IOException`

  - ### write

    public void write(char[] buf) throws IOException
    Overrides:
      `write` in class `Writer`
    Throws:
      `IOException`

  - ### write

    public void write(String s, int off, int len) throws IOException
    Overrides:
      `write` in class `Writer`
    Throws:
      `IOException`

  - ### write

    public void write(String s) throws IOException
    Overrides:
      `write` in class `Writer`
    Throws:
      `IOException`

  - ### newLine

    public void newLine() throws IOException
    Description copied from class: `jakarta.servlet.jsp.JspWriter`
    Write a line separator. The line separator string is defined by the system property `line.separator`, and is not necessarily a single newline ('\n') character.
    Specified by:
      `newLine` in class `JspWriter`
    Throws:
      `IOException` - If an I/O error occurs

  - ### print

    public void print(boolean b) throws IOException
    Description copied from class: `jakarta.servlet.jsp.JspWriter`
    Print a boolean value. The string produced by ``String.valueOf(boolean)`` is written to the JspWriter's buffer or, if no buffer is used, directly to the underlying writer.
    Specified by:
      `print` in class `JspWriter`
    Parameters:
      `b` - The `boolean` to be printed
    Throws:
      `IOException` - If an error occurred while writing

  - ### print

    public void print(char c) throws IOException
    Description copied from class: `jakarta.servlet.jsp.JspWriter`
    Print a character. The character is written to the JspWriter's buffer or, if no buffer is used, directly to the underlying writer.
    Specified by:
      `print` in class `JspWriter`
    Parameters:
      `c` - The `char` to be printed
    Throws:
      `IOException` - If an error occurred while writing

  - ### print

    public void print(int i) throws IOException
    Description copied from class: `jakarta.servlet.jsp.JspWriter`
    Print an integer. The string produced by ``String.valueOf(int)`` is written to the JspWriter's buffer or, if no buffer is used, directly to the underlying writer.
    Specified by:
      `print` in class `JspWriter`
    Parameters:
      `i` - The `int` to be printed
    Throws:
      `IOException` - If an error occurred while writing
    See Also:
      - `Integer.toString(int)`

  - ### print

    public void print(long l) throws IOException
    Description copied from class: `jakarta.servlet.jsp.JspWriter`
    Print a long integer. The string produced by ``String.valueOf(long)`` is written to the JspWriter's buffer or, if no buffer is used, directly to the underlying writer.
    Specified by:
      `print` in class `JspWriter`
    Parameters:
      `l` - The `long` to be printed
    Throws:
      `IOException` - If an error occurred while writing
    See Also:
      - `Long.toString(long)`

  - ### print

    public void print(float f) throws IOException
    Description copied from class: `jakarta.servlet.jsp.JspWriter`
    Print a floating-point number. The string produced by ``String.valueOf(float)`` is written to the JspWriter's buffer or, if no buffer is used, directly to the underlying writer.
    Specified by:
      `print` in class `JspWriter`
    Parameters:
      `f` - The `float` to be printed
    Throws:
      `IOException` - If an error occurred while writing
    See Also:
      - `Float.toString(float)`

  - ### print

    public void print(double d) throws IOException
    Description copied from class: `jakarta.servlet.jsp.JspWriter`
    Print a double-precision floating-point number. The string produced by ``String.valueOf(double)`` is written to the JspWriter's buffer or, if no buffer is used, directly to the underlying writer.
    Specified by:
      `print` in class `JspWriter`
    Parameters:
      `d` - The `double` to be printed
    Throws:
      `IOException` - If an error occurred while writing
    See Also:
      - `Double.toString(double)`

  - ### print

    public void print(char[] s) throws IOException
    Description copied from class: `jakarta.servlet.jsp.JspWriter`
    Print an array of characters. The characters are written to the JspWriter's buffer or, if no buffer is used, directly to the underlying writer.
    Specified by:
      `print` in class `JspWriter`
    Parameters:
      `s` - The array of chars to be printed
    Throws:
      `IOException` - If an error occurred while writing

  - ### print

    public void print(String s) throws IOException
    Description copied from class: `jakarta.servlet.jsp.JspWriter`
    Print a string. If the argument is `null` then the string `"null"` is printed. Otherwise, the string's characters are written to the JspWriter's buffer or, if no buffer is used, directly to the underlying writer.
    Specified by:
      `print` in class `JspWriter`
    Parameters:
      `s` - The `String` to be printed
    Throws:
      `IOException` - If an error occurred while writing

  - ### print

    public void print(Object obj) throws IOException
    Description copied from class: `jakarta.servlet.jsp.JspWriter`
    Print an object. The string produced by the ``String.valueOf(Object)`` method is written to the JspWriter's buffer or, if no buffer is used, directly to the underlying writer.
    Specified by:
      `print` in class `JspWriter`
    Parameters:
      `obj` - The `Object` to be printed
    Throws:
      `IOException` - If an error occurred while writing
    See Also:
      - `Object.toString()`

  - ### println

    public void println() throws IOException
    Description copied from class: `jakarta.servlet.jsp.JspWriter`
    Terminate the current line by writing the line separator string. The line separator string is defined by the system property `line.separator`, and is not necessarily a single newline character (`'\n'`).
    Specified by:
      `println` in class `JspWriter`
    Throws:
      `IOException` - If an error occurred while writing

  - ### println

    public void println(boolean x) throws IOException
    Description copied from class: `jakarta.servlet.jsp.JspWriter`
    Print a boolean value and then terminate the line. This method behaves as though it invokes ``JspWriter.print(boolean)`` and then ``JspWriter.println()``.
    Specified by:
      `println` in class `JspWriter`
    Parameters:
      `x` - the boolean to write
    Throws:
      `IOException` - If an error occurred while writing

  - ### println

    public void println(char x) throws IOException
    Description copied from class: `jakarta.servlet.jsp.JspWriter`
    Print a character and then terminate the line. This method behaves as though it invokes ``JspWriter.print(char)`` and then ``JspWriter.println()`` .
    Specified by:
      `println` in class `JspWriter`
    Parameters:
      `x` - the char to write
    Throws:
      `IOException` - If an error occurred while writing

  - ### println

    public void println(int x) throws IOException
    Description copied from class: `jakarta.servlet.jsp.JspWriter`
    Print an integer and then terminate the line. This method behaves as though it invokes ``JspWriter.print(int)`` and then ``JspWriter.println()`` .
    Specified by:
      `println` in class `JspWriter`
    Parameters:
      `x` - the int to write
    Throws:
      `IOException` - If an error occurred while writing

  - ### println

    public void println(long x) throws IOException
    Description copied from class: `jakarta.servlet.jsp.JspWriter`
    Print a long integer and then terminate the line. This method behaves as though it invokes ``JspWriter.print(long)`` and then ``JspWriter.println()``.
    Specified by:
      `println` in class `JspWriter`
    Parameters:
      `x` - the long to write
    Throws:
      `IOException` - If an error occurred while writing

  - ### println

    public void println(float x) throws IOException
    Description copied from class: `jakarta.servlet.jsp.JspWriter`
    Print a floating-point number and then terminate the line. This method behaves as though it invokes ``JspWriter.print(float)`` and then ``JspWriter.println()``.
    Specified by:
      `println` in class `JspWriter`
    Parameters:
      `x` - the float to write
    Throws:
      `IOException` - If an error occurred while writing

  - ### println

    public void println(double x) throws IOException
    Description copied from class: `jakarta.servlet.jsp.JspWriter`
    Print a double-precision floating-point number and then terminate the line. This method behaves as though it invokes ``JspWriter.print(double)`` and then ``JspWriter.println()``.
    Specified by:
      `println` in class `JspWriter`
    Parameters:
      `x` - the double to write
    Throws:
      `IOException` - If an error occurred while writing

  - ### println

    public void println(char[] x) throws IOException
    Description copied from class: `jakarta.servlet.jsp.JspWriter`
    Print an array of characters and then terminate the line. This method behaves as though it invokes `print(char[])` and then `println()`.
    Specified by:
      `println` in class `JspWriter`
    Parameters:
      `x` - the char[] to write
    Throws:
      `IOException` - If an error occurred while writing

  - ### println

    public void println(String x) throws IOException
    Description copied from class: `jakarta.servlet.jsp.JspWriter`
    Print a String and then terminate the line. This method behaves as though it invokes ``JspWriter.print(String)`` and then ``JspWriter.println()``.
    Specified by:
      `println` in class `JspWriter`
    Parameters:
      `x` - the String to write
    Throws:
      `IOException` - If an error occurred while writing

  - ### println

    public void println(Object x) throws IOException
    Description copied from class: `jakarta.servlet.jsp.JspWriter`
    Print an Object and then terminate the line. This method behaves as though it invokes ``JspWriter.print(Object)`` and then ``JspWriter.println()``.
    Specified by:
      `println` in class `JspWriter`
    Parameters:
      `x` - the Object to write
    Throws:
      `IOException` - If an error occurred while writing

  - ### clear

    public void clear() throws IOException
    Description copied from class: `jakarta.servlet.jsp.JspWriter`
    Clear the contents of the buffer. If the buffer has been already been flushed then the clear operation shall throw an IOException to signal the fact that some data has already been irrevocably written to the client response stream.
    Specified by:
      `clear` in class `JspWriter`
    Throws:
      `IOException` - If an I/O error occurs

  - ### clearBuffer

    public void clearBuffer() throws IOException
    Description copied from class: `jakarta.servlet.jsp.JspWriter`
    Clears the current contents of the buffer. Unlike clear(), this method will not throw an IOException if the buffer has already been flushed. It merely clears the current content of the buffer and returns.
    Specified by:
      `clearBuffer` in class `JspWriter`
    Throws:
      `IOException` - If an I/O error occurs

  - ### close

    public void close() throws IOException
    Description copied from class: `jakarta.servlet.jsp.JspWriter`
    Close the stream, flushing it first.

    This method needs not be invoked explicitly for the initial JspWriter as the code generated by the JSP container will automatically include a call to close().

    Closing a previously-closed stream, unlike flush(), has no effect.

    Specified by:
      `close` in interface `AutoCloseable`
    Specified by:
      `close` in interface `Closeable`
    Specified by:
      `close` in class `JspWriter`
    Throws:
      `IOException` - If an I/O error occurs

  - ### getBufferSize

    public int getBufferSize()
    Description copied from class: `jakarta.servlet.jsp.JspWriter`
    This method returns the size of the buffer used by the JspWriter.
    Overrides:
      `getBufferSize` in class `JspWriter`
    Returns:
      the size of the buffer in bytes, or 0 is unbuffered.

  - ### getRemaining

    public int getRemaining()
    Description copied from class: `jakarta.servlet.jsp.JspWriter`
    This method returns the number of unused bytes in the buffer.
    Specified by:
      `getRemaining` in class `JspWriter`
    Returns:
      the number of bytes unused in the buffer

  - ### getReader

    public Reader getReader()
    Description copied from class: `jakarta.servlet.jsp.tagext.BodyContent`
    Return the value of this BodyContent as a Reader.
    Specified by:
      `getReader` in class `BodyContent`
    Returns:
      the value of this BodyContent as a Reader

  - ### getString

    public String getString()
    Description copied from class: `jakarta.servlet.jsp.tagext.BodyContent`
    Return the value of the BodyContent as a String.
    Specified by:
      `getString` in class `BodyContent`
    Returns:
      the value of the BodyContent as a String

  - ### writeOut

    public void writeOut(Writer out) throws IOException
    Description copied from class: `jakarta.servlet.jsp.tagext.BodyContent`
    Write the contents of this BodyContent into a Writer. Subclasses may optimize common invocation patterns.
    Specified by:
      `writeOut` in class `BodyContent`
    Parameters:
      `out` - The writer into which to place the contents of this body evaluation
    Throws:
      `IOException` - if an I/O error occurred while writing the contents of this BodyContent to the given Writer

  - ### recycle

    protected void recycle()
    This method shall "reset" the internal state of a BodyContentImpl, releasing all internal references, and preparing it for potential reuse by a later invocation of `PageContextImpl.pushBody(Writer)`.

    Note, that BodyContentImpl instances are usually owned by a PageContextImpl instance, and PageContextImpl instances are recycled and reused.

    See Also:
      - `PageContextImpl.release()`